Loading...
Searching...
No Matches
Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet > Class Template Reference

A visitor/mutator capable of passing arbitrary arguments to the visit methods using CRTP and returning any types from them. More...

`#include <IRVisitor.h>`

## Public Member Functions

template<typename... Args>
HALIDE_ALWAYS_INLINE StmtRet | dispatch (const Stmt &s, Args &&...args)
template<typename... Args>
HALIDE_ALWAYS_INLINE StmtRet | dispatch (Stmt &&s, Args &&...args)
template<typename... Args>
HALIDE_ALWAYS_INLINE ExprRet | dispatch (const Expr &e, Args &&...args)
template<typename... Args>
HALIDE_ALWAYS_INLINE ExprRet | dispatch (Expr &&e, Args &&...args)

## Detailed Description

template<typename T, typename ExprRet, typename StmtRet>
class Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet >

A visitor/mutator capable of passing arbitrary arguments to the visit methods using CRTP and returning any types from them.

All Expr visitors must have the same signature, and all Stmt visitors must have the same signature. Does not have default implementations of the visit methods.

Definition at line 163 of file IRVisitor.h.

## Member Function Documentation

## dispatch() [1/4]

template<typename T, typename ExprRet, typename StmtRet>
template<typename... Args>

HALIDE_ALWAYS_INLINE StmtRet Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet >::dispatch | ( | const Stmt & | s,
|  | Args &&... | args )

inline

Definition at line 337 of file IRVisitor.h.

## dispatch() [2/4]

template<typename T, typename ExprRet, typename StmtRet>
template<typename... Args>

HALIDE_ALWAYS_INLINE StmtRet Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet >::dispatch | ( | Stmt && | s,
|  | Args &&... | args )

inline

Definition at line 342 of file IRVisitor.h.

## dispatch() [3/4]

template<typename T, typename ExprRet, typename StmtRet>
template<typename... Args>

HALIDE_ALWAYS_INLINE ExprRet Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet >::dispatch | ( | const Expr & | e,
|  | Args &&... | args )

inline

Definition at line 347 of file IRVisitor.h.

## dispatch() [4/4]

template<typename T, typename ExprRet, typename StmtRet>
template<typename... Args>

HALIDE_ALWAYS_INLINE ExprRet Halide::Internal::VariadicVisitor< T, ExprRet, StmtRet >::dispatch | ( | Expr && | e,
|  | Args &&... | args )

inline

Definition at line 352 of file IRVisitor.h.

The documentation for this class was generated from the following file:

- src/IRVisitor.h